PPI::Statement::Variable(3pm)

NAME
PPI::Statement::Variable - Variable declaration statements

SYNOPSIS
  # All of the following are variable declarations
  my $foo = 1;
  my ($foo, $bar) = (1, 2);
  our $foo = 1;
  local $foo;
  local $foo = 1;
  LABEL: my $foo = 1;

INHERITANCE
  PPI::Statement::Variable
  isa PPI::Statement::Expression
      isa PPI::Statement
          isa PPI::Node
              isa PPI::Element

DESCRIPTION
The main intent of the "PPI::Statement::Variable" class is to describe simple statements that explicitly declare new local or global variables.

Note that this does not make it exclusively the only place where variables are defined, and later on you should expect that the "variables" method will migrate deeper down the tree to either PPI::Statement or PPI::Node to recognise this fact, but for now it stays here.

METHODS

  type
The "type" method checks and returns the declaration type of the statement, which will be one of 'my', 'local', 'our', or 'state'.

Returns a string of the type, or "undef" if the type cannot be detected (which is probably a bug).

  variables
As for several other PDOM Element types that can declare variables, the "variables" method returns a list of the canonical forms of the variables defined by the statement.

Returns a list of the canonical string forms of variables, or the null list if it is unable to find any variables.

  symbols
Returns a list of the variables defined by the statement, as PPI::Token::Symbols.

TO DO
- Write unit tests for this

SUPPORT
See the support section in the main module.

AUTHOR
Adam Kennedy <adamk@cpan.org>

COPYRIGHT
Copyright 2001 - 2011 Adam Kennedy.

This program is free software; you can redistribute it and/or modify it under the same terms as Perl itself.

The full text of the license can be found in the LICENSE file included with this module.